{
 This demo shows how to generate document in ScaleRichView, including page
 headers and footers.

 GenerateHeader, GenerateFooter and GenerateMain use "viewer-style" methods
 for generating a new document: Clear, then AddItem, AddPictureEx, AddTextNL.

 InsertMain uses "editor-style" methods: InsertItem, InsertPicture, InsertText

 See: http://www.trichview.com/help/viewer_vs_editor.html


}

unit Unit7;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  Jpeg, RVScroll, SclRView, RVFieldItems,
  Buttons, ExtCtrls,
  RVStyle, RVItem, CRVData, RVTable, RVEdit, RVGrHandler;

type
  TForm7 = class(TForm)
    SRichViewEdit1: TSRichViewEdit;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GenerateHeader(RVData: TCustomRVData; IncludeCompanyData: Boolean);
    procedure GenerateFooter(RVData: TCustomRVData);
    procedure GenerateMain(RVData: TCustomRVData);
    procedure InsertMain(RichViewEdit: TCustomRichViewEdit);
    procedure GenerateDoc;

  end;

var
  Form7: TForm7;

implementation

{$R *.dfm}

const
  S_HEADCTITLE = 'Around Africa Tourism';
  S_HEADCTEXT =
    'Reg No.:'#9'12345'#13#10 +
    'Tax No.:'#13#10 +
    'Phone No.:'#9'012 345 6789'#13#10 +
    'Mobile No.:'#9'098 765 4321'#13#10 +
    'Fax No.:'#9'011 234 5678'#13#10 +
    'SMS No.:'#13#10 +
    'E-Mail:'#9'demogenerator@aroundafricatourism.com'#13#10 +
    'Website:'#9'www.aroundafricatourism.com'#13#10 +
    'IATA No.:'#9'ZA 03030/844';
  S_FOOTER = 'Document Generation Demo';
  S_HEADTITLE1 = 'TOUR ITINERARY - for Mr. Jon Dolittle';
  S_HEADTITLE2 = 'Escape to the Cape - Sight Seeing';

  S_START1 = 'ITINERARY: Escape to the Cape';
  S_START2 = 'APPROX. DISTANCE: 240 Km';
  S_START3 = 'REGION VISITED:';
  S_START4 = 'APPROX. DURATION: 9 hours';

  S_START5 =
    'Days Daily'#9'08h30-17h30'#13#10 +
    'Departure Downtown Hotels'#9'08h15'#13#10 +
    'Waterfront Hotels'#9'08h30'#13#10 +
    'Sea Point Hotels'#9'08h45';

  S_TEXT =
    'Duration 9 hours'#13#10 +
    'Entrance included None'#13#10 +
    'Meals included Cape of Good Hope Nature Reserve& Boulders Penguin Colony & Wine tasting'#13#10 +
    'Comments The drive via Chapmans peak is subject to the road being open, alternatively we will drive via Ou Kaapse Weg.'#13#10 +
    'This tour encapsulates the best that the Cape has to offer, an awe- inspiring tour of the headland known as Cape ' +
    'Point. Magnificent beaches, breathtaking views, historic and picturesque coastal villages are to be seen along the ' +
    'way. The Cape Peninsula is one of the worlds most scenic areas and stretches from the City centre to Cape Point. ' +
    'Enjoy a delightful drive which winds its way to the heart of the Cape Winelands, through superb mountain ranges, ' +
    'vineyards and Cape Dutch homesteads.'#13#10 +
    'We travel along the Atlantic Seaboard via Sea Point, Clifton and Camps Bay, stopping at a Llandudno look-out point '+
    'before continuing to Hout Bay, a quaint village and fishing harbour with magnificent mountain views and beach.'#13#10 +
    'Optional: Seal Island boat trip (seasonal, weather permitting) (not included in cost). On through Chapmans Peak, ' +
    'one of the worlds most breathtaking coastal drives, to Cape Point and the Good Hope Nature Reserve, which has ' +
    'magnificent fynbos vegetation, birdlife, endemic antelope species and zebra, historic lighthouses and shipwrecks. ' +
    'Cape Point is perceived to be the meeting point of the Atlantic and Indian Oceans.'#13#10 +
    'We go on to historic Simons Town, a village with charming Victorian architecture, a naval base and a large penguin '+
    'colony at the beautiful Boulders Beach. Enjoy a light lunch at a nearby restaurant (not included in cost). '#13#10 +
    'Our next stop is Stellenbosch, the heart of the South African wine Industry, boasting great beauty and culture that is '+
    'steeped in South African history. Walk down the canal-lined avenues, in the shade of giant oak trees and beautifully ' +
    'preserved historic buildings. Coffee shops, galleries, antique shops and wine bars spill onto the sidewalks. An air of ' +
    'quiet intellectualism and wine-making history abounds in this university town. With the sheer vastness of wine estates ' +
    'on offer, we are truly spoilt for choice when we enjoy a cellar tour and wine tasting in Stellenbosch. We return to the ' +
    'bustle of city life after an enthralling day in the countryside, arriving back at the hotels at approximately 17:30.';

procedure TForm7.FormCreate(Sender: TObject);
begin
  GenerateDoc;
end;

procedure TForm7.GenerateDoc;
begin
  SRichViewEdit1.PageProperty.TitlePage := True;
  SRichViewEdit1.UnitsProgram := rvuMillimeters;
  SRichViewEdit1.PageProperty.LeftMargin := 15;
  SRichViewEdit1.PageProperty.RightMargin := 15;
  SRichViewEdit1.PageProperty.PageNoVisible := False;

  //SRichViewEdit1.RVOptions := SRichViewEdit1.RVOptions - [rvoShowGridLines];

  GenerateHeader(SRichViewEdit1.SubDocuments[srvhftFirstPageHeader], True);
  GenerateHeader(SRichViewEdit1.SubDocuments[srvhftNormalHeader], False);
  GenerateFooter(SRichViewEdit1.SubDocuments[srvhftFirstPageFooter]);
  GenerateMain(SRichViewEdit1.RichViewEdit.RVData);
  SRichViewEdit1.Format;
end;

// Returns index of item in RVStyle.TextStyles with the specified properties
// (it is created, if necessary)
function GetTextStyle(RVStyle: TRVStyle; Size: Integer; Style: TFontStyles = [];
  Color: TColor = clWindowText; FontName: String = 'Arial'): Integer;
var
  TextStyle: TFontInfo;
begin
  TextStyle := TFontInfo.Create(nil);
  TextStyle.Assign(RVStyle.TextStyles[0]);
  TextStyle.Size := Size;
  TextStyle.Style := Style;
  TextStyle.Color := Color;
  TextStyle.FontName := FontName;
  Result := RVStyle.FindTextStyle(TextStyle);
  TextStyle.Free;
end;

// Returns index of item in RVStyle.ParaStyles with the specified properties
// (it is created, if necessary)
function GetParaStyle(RVStyle: TRVStyle; Alignment: TRVAlignment;
  SpaceBeforeAndAfter: TRVStyleLength = 0;
  TabStop: TRVStyleLength = -1; BackColor: TColor = clNone;
  BorderColor: TColor = clNone): Integer;
var
  ParaStyle: TParaInfo;
  BorderOffs: TRVStyleLength;
begin
  ParaStyle := TParaInfo.Create(nil);
  ParaStyle.Assign(RVStyle.ParaStyles[0]);
  ParaStyle.Alignment := Alignment;
  ParaStyle.SpaceBefore := SpaceBeforeAndAfter;
  ParaStyle.SpaceAfter := SpaceBeforeAndAfter;
  if TabStop >= 0 then
    with ParaStyle.Tabs.Add do
      Position := TabStop;
  ParaStyle.Background.Color := BackColor;
  if BorderColor <> clNone then
  begin
    ParaStyle.Border.Color := BorderColor;
    ParaStyle.Border.Width := RVStyle.PixelsToUnits(1);
    ParaStyle.Border.Style := rvbSingle;
  end;
  if (BorderColor <> clNone) or (BackColor <> clNone) then
  begin
    BorderOffs := RVStyle.PixelsToUnits(5);
    ParaStyle.Border.BorderOffsets.SetAll(BorderOffs);
    ParaStyle.Background.BorderOffsets.SetAll(BorderOffs);
    ParaStyle.SpaceBefore := ParaStyle.SpaceBefore + BorderOffs;
    ParaStyle.SpaceAfter := ParaStyle.SpaceAfter + BorderOffs;
    ParaStyle.LeftIndent := ParaStyle.LeftIndent + BorderOffs;
    ParaStyle.RightIndent := ParaStyle.RightIndent + BorderOffs;
  end;
  Result := RVStyle.FindParaStyle(ParaStyle);
  ParaStyle.Free;
end;

// Generating page header
procedure TForm7.GenerateHeader(RVData: TCustomRVData; IncludeCompanyData: Boolean);
var
  Table: TRVTableItemInfo;
  Graphic: TGraphic;
  CenteredParaNo, TabbedParaNo, NormalParaNo, ColoredParaNo, RightParaNo,
  BoldTextNo, NormalTextNo, BigBoldTextNo: Integer;
  RVStyle: TRVStyle;
  Cell: TRVTableCellData;
  PageNoItem: TRVPageNumberItemInfo;
begin
  RVData.Clear;
  RVStyle := RVData.GetRVStyle;
  // creating text and paragraph styles
  CenteredParaNo := GetParaStyle(RVStyle, rvaCenter);
  NormalParaNo := GetParaStyle(RVStyle, rvaLeft);
  RightParaNo := GetParaStyle(RVStyle, rvaRight);
  ColoredParaNo := GetParaStyle(RVStyle, rvaLeft, RVStyle.PixelsToUnits(1),
    0, $006CD9, clBlack);
  BoldTextNo := GetTextStyle(RVStyle, 10, [fsBold]);
  NormalTextNo := GetTextStyle(RVStyle, 10, []);
  BigBoldTextNo := GetTextStyle(RVStyle, 14, [fsBold]);
  // making table 1 ( logo | company info)
  Table := TRVTableItemInfo.CreateEx(1, 2, RVData);
  Table.ParaNo := CenteredParaNo;
  Table.BorderWidth := 0;
  Table.Color := clNone;
  Table.BestWidth := -100;
  Table.Cells[0, 0].BestWidth := -50;
  Table.Cells[0, 1].BestWidth := -50;

  Cell := Table.Cells[0, 0];
  Cell.Clear;
  Cell.VAlign := rvcMiddle;
  Graphic := RVGraphicHandler.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Logo.jpg');
  // (if loading was not successful, Graphic = nil)
  Cell.AddPictureEx('', Graphic, CenteredParaNo, rvvaBaseline);
  // resizing the added picture by 1.2
  Cell.SetItemExtraIntProperty(Cell.ItemCount - 1, rvepImageWidth,
    RVStyle.PixelsToUnits(Round(RVStyle.PixelsToUnits(Graphic.Width) * 1.2)));
  Cell.SetItemExtraIntProperty(Cell.ItemCount - 1, rvepImageHeight,
    RVStyle.PixelsToUnits(Round(RVStyle.PixelsToUnits(Graphic.Height) * 1.2)));

  Cell := Table.Cells[0, 1];
  Cell.Clear;
  if IncludeCompanyData then
  begin
    TabbedParaNo := GetParaStyle(RVStyle, rvaLeft, 0, RVStyle.PixelsToUnits(100));
    Cell.AddTextNL(S_HEADCTITLE, BoldTextNo, TabbedParaNo, TabbedParaNo);
    Cell.AddTextNL(S_HEADCTEXT, NormalTextNo, TabbedParaNo, TabbedParaNo);
  end;
  RVData.AddItem('', Table);

  // making table 2
  // ( ITINERARY | Page no )
  // ( colored line        )
  Table := TRVTableItemInfo.CreateEx(2, 2, RVData);
  Table.ParaNo := CenteredParaNo;
  Table.BorderWidth := 0;
  Table.Color := clNone;
  Table.BestWidth := -100;
  Table.Cells[0, 0].BestWidth := -80;
  Table.Cells[0, 1].BestWidth := -20;
  Cell := Table.Cells[0, 0];
  Cell.Clear;
  Cell.AddTextNL(S_HEADTITLE1, BigBoldTextNo, NormalParaNo, NormalParaNo);
  Cell := Table.Cells[0, 1];
  Cell.Clear;
  PageNoItem := TRVPageNumberItemInfo.CreateEx(RVData, rvpntDecimal, BigBoldTextNo);
  PageNoItem.ParaNo := RightParaNo;
  Cell.AddItem('', PageNoItem);
  Table.MergeCells(1, 0, 2, 1, True);
  Cell := Table.Cells[1, 0];
  Cell.Clear;
  Cell.AddTextNL(S_HEADTITLE2, BigBoldTextNo, ColoredParaNo, ColoredParaNo);
  RVData.AddItem('', Table);
end;

// Generating page footer
procedure TForm7.GenerateFooter(RVData: TCustomRVData);
var
  RVStyle: TRVStyle;
  ParaNo, TextNo: Integer;
begin
  RVStyle := RVData.GetRVStyle;
  ParaNo := GetParaStyle(RVStyle, rvaLeft);
  TextNo := GetTextStyle(RVStyle, 10, [fsBold]);
  RVData.Clear;
  RVData.AddTextNL(S_FOOTER, TextNo, ParaNo, ParaNo);
end;

// Generating main document
procedure TForm7.GenerateMain(RVData: TCustomRVData);
var
  Table: TRVTableItemInfo;
  RVStyle: TRVStyle;
  Cell: TRVTableCellData;
  CenteredParaNo, NormalParaNo, SpacedParaNo, TabbedParaNo,
  BigBoldTextNo, ColoredTextNo: Integer;
  Graphic: TGraphic;
begin
  RVData.Clear;
  RVStyle := RVData.GetRVStyle;
  CenteredParaNo := GetParaStyle(RVStyle, rvaCenter, RVStyle.PixelsToUnits(5));
  NormalParaNo := GetParaStyle(RVStyle, rvaLeft);
  SpacedParaNo := GetParaStyle(RVStyle, rvaLeft, RVStyle.PixelsToUnits(5));
  TabbedParaNo := GetParaStyle(RVStyle, rvaLeft, 0, RVStyle.PixelsToUnits(300));
  BigBoldTextNo := GetTextStyle(RVStyle, 14, [fsBold]);
  ColoredTextNo := GetTextStyle(RVStyle, 14, [], clMaroon);
  Table := TRVTableItemInfo.CreateEx(1, 2, RVData);
  Table.ParaNo := CenteredParaNo;
  Table.BorderWidth := 0;
  Table.Color := clNone;
  Table.BestWidth := -100;
  Table.Cells[0, 0].BestWidth := -50;
  Table.Cells[0, 1].BestWidth := -50;
  Cell := Table.Cells[0, 0];
  Cell.Clear;
  Cell.AddTextNL(S_START1 + #13#10 + S_START2, BigBoldTextNo, NormalParaNo, NormalParaNo);
  Cell := Table.Cells[0, 1];
  Cell.Clear;
  Cell.AddTextNL(S_START3 + #13#10 + S_START4, BigBoldTextNo, NormalParaNo, NormalParaNo);
  RVData.AddItem('', Table);
  Graphic := RVGraphicHandler.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Photo.jpg');
  // (if loading was not successful, Graphic = nil)
  RVData.AddPictureEx('', Graphic, CenteredParaNo, rvvaBaseline);
  // resizing the added picture by 1.5
  RVData.SetItemExtraIntProperty(Cell.ItemCount - 1, rvepImageWidth,
    RVStyle.PixelsToUnits(Round(RVStyle.PixelsToUnits(Graphic.Width) * 1.5)));
  RVData.SetItemExtraIntProperty(Cell.ItemCount - 1, rvepImageHeight,
    RVStyle.PixelsToUnits(Round(RVStyle.PixelsToUnits(Graphic.Height) * 1.5)));
  RVData.AddTextNL(S_START5 + #13#10, ColoredTextNo, TabbedParaNo, TabbedParaNo);
  RVData.AddTextNL(S_TEXT, ColoredTextNo, SpacedParaNo, SpacedParaNo);
end;

// Inserting in main document.
// It adds the same data as GenerateMain, but:
// - they are inserted as an editing (undoable) operation
// - they are inserted in the caret position
procedure TForm7.InsertMain(RichViewEdit: TCustomRichViewEdit);
var
  Table: TRVTableItemInfo;
  RVStyle: TRVStyle;
  Cell: TRVTableCellData;
  CenteredParaNo, NormalParaNo, SpacedParaNo, TabbedParaNo,
  BigBoldTextNo, ColoredTextNo: Integer;
  Graphic: TGraphic;
begin
  RichViewEdit := RichViewEdit.TopLevelEditor;
  RVStyle := RichViewEdit.Style;
  CenteredParaNo := GetParaStyle(RVStyle, rvaCenter, RVStyle.PixelsToUnits(5));
  NormalParaNo := GetParaStyle(RVStyle, rvaLeft);
  SpacedParaNo := GetParaStyle(RVStyle, rvaLeft, RVStyle.PixelsToUnits(5));
  TabbedParaNo := GetParaStyle(RVStyle, rvaLeft, 0, RVStyle.PixelsToUnits(300));
  BigBoldTextNo := GetTextStyle(RVStyle, 14, [fsBold]);
  ColoredTextNo := GetTextStyle(RVStyle, 14, [], clMaroon);

  RichViewEdit.BeginUndoGroup(rvutInsert);
  RichViewEdit.SetUndoGroupMode(True);
  try
    Table := TRVTableItemInfo.CreateEx(1, 2, RichViewEdit.RVData);
    Table.ParaNo := CenteredParaNo;
    Table.BorderWidth := 0;
    Table.Color := clNone;
    Table.BestWidth := -100;
    Table.Cells[0, 0].BestWidth := -50;
    Table.Cells[0, 1].BestWidth := -50;
    Cell := Table.Cells[0, 0];
    Cell.Clear;
    Cell.AddTextNL(S_START1 + #13#10 + S_START2, BigBoldTextNo, NormalParaNo, NormalParaNo);
    Cell := Table.Cells[0, 1];
    Cell.Clear;
    Cell.AddTextNL(S_START3 + #13#10 + S_START4, BigBoldTextNo, NormalParaNo, NormalParaNo);
    RichViewEdit.InsertItem('', Table);
    RichViewEdit.ApplyParaStyle(CenteredParaNo);

    Graphic := RVGraphicHandler.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Photo.jpg');
    // (if loading was not successful, Graphic = nil)
    RichViewEdit.InsertPicture('', Graphic, rvvaBaseline);
    // resizing the inserted picture by 1.5
    RichViewEdit.SetCurrentItemExtraIntProperty(rvepImageWidth,
      RVStyle.PixelsToUnits(Round(RVStyle.PixelsToUnits(Graphic.Width) * 1.5)), True);
    RichViewEdit.SetCurrentItemExtraIntProperty(rvepImageHeight,
      RVStyle.PixelsToUnits(Round(RVStyle.PixelsToUnits(Graphic.Height) * 1.5)), True);
    RichViewEdit.InsertText(#13#10);
    RichViewEdit.ApplyParaStyle(TabbedParaNo);

    RichViewEdit.CurTextStyleNo := ColoredTextNo;
    RichViewEdit.InsertText(S_START5 + #13#10#13#10);
    RichViewEdit.ApplyParaStyle(SpacedParaNo);
    RichViewEdit.InsertText(S_TEXT);
  finally
    RichViewEdit.SetUndoGroupMode(False);
  end;
end;

procedure TForm7.SpeedButton1Click(Sender: TObject);
begin
  SRichViewEdit1.StartEditing(srvrveMain);
  SRichViewEdit1.CanUpdate := False;
  try
    InsertMain(SRichViewEdit1.RichViewEdit);
  finally
    SRichViewEdit1.CanUpdate := True;
  end;
end;

end.

